#!/usr/bin/perl -w

my $DEBUG = 0;
my $MIFACE = "eth1";
my $MAXN = 9999;

my $HTSIPTVDIR = "~/.hts/tvheadend/iptvservices";
# my $HTSIPTVDIR = "~/.hts/tvheadend/iptvtransports"; // old version
my $fcount = 1000;

# Check $HTSIPTVDIR exist?
### glob возвращает СПИСОК!!! нестабильно работает как скаляр
my @lghtsiptvdir = glob($HTSIPTVDIR);
my $ghtsiptvdir = $lghtsiptvdir[0];
die "Directory '$ghtsiptvdir' is not exist or not writable\n"
	if !(-w $ghtsiptvdir);

sub out_tvheadend;

while (defined($line = <>) ) {
    if ($line =~ /#EXTINF:.*,\s*(.*)(\s*)/) {
	$channel_name = $1;
	$channel_name =~ s/\r+//;

        if (defined($line = <>)
		and ($line =~ '(udp|rtp)://@?(\d+\.\d+\.\d+\.\d+):(\d+)')) {
	    $mproto = $1; $mgroup = $2; $mport = $3;
	    $murl = $line;
	}
	out_tvheadend;
    }
}

sub out_tvheadend
{
	do 
	{ # ищем несуществующий файл iptv_ с номером $fcount
	    $fname = sprintf "%s/iptv_%04u", $ghtsiptvdir, ++$fcount;
	} until (!(-e $fname) and ($fcount < $MAXN));

	print $fcount, " ", $channel_name, " ", $fname, "\n" if $DEBUG;

	if (!(open(FH, ">", $fname))) {
	    warn "Couldn't open $fname for writing: $!\n"
	}
	else {
	    print FH "{\n";
	    print FH "\t\"pmt\": 0,\n";
	    print FH "\t\"port\": $mport,\n";
	    print FH "\t\"interface\": \"$MIFACE\",\n";
	    print FH "\t\"group\": \"$mgroup\",\n";
	    print FH "\t\"channelname\": \"$channel_name\",\n";
	    print FH "\t\"mapped\": 1,\n";
	    print FH "\t\"pcr\": 0,\n";
	    print FH "\t\"disabled\": 0\n";
	    print FH "}\n";
	    close FH or warn "Couldn't close $fname: $!\n";
	} 
}
